## opengm 2.3.6

=== CMakeLists.txt ===
#--------------------------------------------------------------
# default build-type (release)
# (the next lines must be called bevore project(opengm2))
#--------------------------------------------------------------
IF(DEFINED CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ELSE()
   SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF()

#--------------------------------------------------------------
# OpenGM
#--------------------------------------------------------------
cmake_minimum_required(VERSION 2.6)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
project(opengm2)
set (OPENGM_VERSION_MAJOR 2)
set (OPENGM_VERSION_MINOR 3)
set (OPENGM_VERSION_PATCH 1)

#--------------------------------------------------------------
# global headers
#--------------------------------------------------------------
file(GLOB_RECURSE headers include/*.hxx)
include_directories(include)

#--------------------------------------------------------------
# debug info
#--------------------------------------------------------------
#add_definitions(-DTRWS_DEBUG_OUTPUT)

#--------------------------------------------------------------
# warning level
#-------------------------------------------------------------- 
SET(WARNINGLEVEL "0" CACHE STRING "selected level for compiler warning from  0 (sloppy) to 4 (sadistic)") 
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
   # no warnings
   if(WARNINGLEVEL STREQUAL "0" )
     message(STATUS "--------------------------------------------------------------------------")
     message(STATUS "WARNING: Compiler warnings are very sloppy -> increase CMake-WARNINGLEVEL")
     message(STATUS "--------------------------------------------------------------------------")
   endif()
   # with warning
   if(WARNINGLEVEL STREQUAL "1" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98")
   endif()
   # PEDANTIC -> a lot of warnings
   if(WARNINGLEVEL STREQUAL "2" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98 -pedantic -Wno-long-long ")
   endif() 
   # VERY PEDANTIC -> very lot of warnings
   if(WARNINGLEVEL STREQUAL "3" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98 -pedantic -Wno-long-long -Wextra")
   endif()
   # SADISTIC -> all warnings become errors
   if(WARNINGLEVEL STREQUAL "4" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98 -pedantic -Wno-long-long -Wextra -Werror")
   endif()
elseif(MSVC)
   add_definitions(-D_SCL_SECURE_NO_WARNINGS)
endif()


#--------------------------------------------------------------
# options
#--------------------------------------------------------------
OPTION(BUILD_EXAMPLES "Build Examples" ON)
OPTION(BUILD_TUTORIALS "Build Tutorials" ON)
OPTION(BUILD_COMMANDLINE "Build Commandline" OFF)
OPTION(WITH_AD3 "Include AD3" OFF)
OPTION(WITH_CPLEX "Include CPLEX" OFF)
OPTION(WITH_GUROBI "Include GUROBI" OFF)
OPTION(WITH_BOOST "Include BOOST" OFF)
OPTION(WITH_HDF5 "Include HDF5" OFF)
OPTION(WITH_TRWS "Include wrapper for TRWS code" OFF)
OPTION(WITH_GCO "Include wrapper for GCO code" OFF)
OPTION(WITH_MRF "Include wrapper for MRF code" OFF)
OPTION(WITH_QPBO "Include wrapper for QPBO code" OFF)
OPTION(WITH_FASTPD "Include wrapper for FastPD code" OFF)
OPTION(WITH_MAXFLOW "Include wrapper for MAXFLOW code" OFF)
OPTION(WITH_MAXFLOW_IBFS "Include wrapper for MAXFLOW-IBFScode" OFF)
OPTION(WITH_LIBDAI "Include wrapper for LIBDAI code" OFF)
OPTION(WITH_DAOOPT "Include wrapper for DAOOPT code" OFF)
OPTION(WITH_MPLP "Include wrapper for MPLP code" OFF)
OPTION(WITH_SRMP "Include wrapper for SRMP code" OFF)
OPTION(WITH_PLANARITY "Include wrapper for PLANARITY code" OFF)
OPTION(WITH_BLOSSOM5 "Include wrapper for BLOSSOM5 code" OFF)
OPTION(WITH_OPENMP "Include OpenMP" OFF)
OPTION(WITH_VIGRA "Include VIGRA" OFF)
OPTION(WITH_CONICBUNDLE "Include ConicBundleLibrary" OFF)
OPTION(WITH_MATLAB "Activate MatLab-Code" OFF)
OPTION(BUILD_CONVERTER "Build several converters" OFF)
OPTION(BUILD_PYTHON_WRAPPER "Build python wrapper" OFF)
OPTION(BUILD_MATLAB_WRAPPER "Build matlab wrapper" OFF)
###Grante needs C++11. Since we have not tested OpenGM under this standard yet, using Grante is realy experimental!!!
###OPTION(WITH_GRANTE "Include wrapper for grante" OFF)

#--------------------------------------------------------------
# Cplex
#--------------------------------------------------------------
if(WITH_CPLEX)
   message(STATUS "build with CPLEX interface")
   find_package(CPLEX REQUIRED)
   add_definitions(-DWITH_CPLEX)
   include_directories(${CPLEX_INCLUDE_DIRS})
   # add_definitions(-DILOUSESTL) redundant according to http://www-01.ibm.com/support/docview.wss?uid=swg21399983
   add_definitions(-DIL_STD)
else()
   message(STATUS "build without CPLEX interface")
endif()


#--------------------------------------------------------------
# AD3
#--------------------------------------------------------------
if(WITH_AD3)
   #message(STATUS "build with AD3 interface")
   #find_package(AD3 REQUIRED)
   #add_definitions(-DWITH_AD3)
   #include_directories(${AD3_INCLUDE_DIR})


  message(STATUS "build with external inference algorithm AD3")
  SET(AD3_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/AD3-patched" CACHE STRING "AD3 patched source code directory")
  add_definitions(-DWITH_AD3)
  include_directories(${AD3_PATCHEDSRCDIR})



else()
   message(STATUS "build without AD3 interface")
endif()

#--------------------------------------------------------------
# Gurobi
#--------------------------------------------------------------
if(WITH_GUROBI)
   message(STATUS "build with GUROBI interface")
   find_package(GUROBI REQUIRED)
   add_definitions(-DWITH_GUROBI)
   include_directories(${GUROBI_INCLUDE_DIRS})
else()
   message(STATUS "build without GUROBI interface")
endif()



#--------------------------------------------------------------
# Boost
#--------------------------------------------------------------
if(WITH_BOOST)
   message(STATUS "build with Boost")
   find_package(Boost 1.47 REQUIRED)
   add_definitions(-DWITH_BOOST)
   add_definitions(-DWITH_BOOST_GRAPH)
   include_directories(${Boost_INCLUDE_DIR})
else()
   message(STATUS "build without Boost")
endif()

#--------------------------------------------------------------
# HDF5
#--------------------------------------------------------------
if(WITH_HDF5)
   message(STATUS "build with HDF5 support")
   if(WIN32)
     # FindHDF5 is broken on Windows
     # it wrongly discovers the dlls instead of the lib files
     # see: www.cmake.org/Bug/bug_relationship_graph.php?bug_id=14111
     # therefore we set the variable manually
     find_library( HDF5_IMPORT_LIB NAMES hdf5 hdf5dll )
     find_library( HDF5_HL_IMPORT_LIB NAMES hdf5_hl hdf5_hldll )
     find_path(HDF5_INCLUDE_DIR hdf5.h)
     set( HDF5_LIBRARIES ${HDF5_IMPORT_LIB} ${HDF5_HL_IMPORT_LIB} )
     message(STATUS "HDF5: autodiscovery is broken on WIN32; using global search paths")
     message(STATUS "HDF5: found ${HDF5_LIBRARIES}")
   else()
     find_package(HDF5 REQUIRED)
   endif()
   include_directories(${HDF5_INCLUDE_DIR})
   add_definitions(${HDF5_CPPFLAGS})
   add_definitions(-DWITH_HDF5)
else()
   message(STATUS "build without HDF5")
endif()

#--------------------------------------------------------------
# MATLAB
#--------------------------------------------------------------
if(WITH_MATLAB)
  message(STATUS "build with MatLab support")
  find_package(MATLAB REQUIRED)
  message(STATUS "Matlab include dir: ${MATLAB_INCLUDE_DIR}")
  message(STATUS "Matlab libmex: ${MATLAB_MEX_LIBRARY}")
  message(STATUS "Matlab libeng: ${MATLAB_ENG_LIBRARY}")
  message(STATUS "Matlab libmx:  ${MATLAB_MX_LIBRARY}")

  #include_directories(${MATLAB_INCLUDE_DIR})
  #add_definitions(-DWITH_MATLAB)
endif(WITH_MATLAB)

#--------------------------------------------------------------
# TRWS
#--------------------------------------------------------------
if(WITH_TRWS)
   message(STATUS "build with external inference algorithm TRWS")
   SET(TRWS_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/TRWS-v1.3.src-patched" CACHE STRING "TRWS patched source code directory")
   add_definitions(-DWITH_TRWS)
   include_directories(${TRWS_PATCHEDSRCDIR})
else()
   message(STATUS "build without external inference algorithm TRWS")
endif(WITH_TRWS)

#--------------------------------------------------------------
# GCO
#--------------------------------------------------------------
if(WITH_GCO)
   message(STATUS "build with external inference algorithm GCO")
   SET(GCO_LABEL_VALUE "int" CACHE STRING "selected label type for GCO library")
   add_definitions(-DGCOLABELVALUE=${GCO_LABEL_VALUE})
   SET(GCO_ENERGY_VALUE "double" CACHE STRING "selected energy type for GCO library")
   add_definitions(-DGCOENERGYVALUE=${GCO_ENERGY_VALUE})
   SET(GCO_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/GCO-v3.0.src-patched" CACHE STRING "GCO patched source code directory")
   add_definitions(-DWITH_GCO)
   include_directories(${GCO_PATCHEDSRCDIR})
else()
   message(STATUS "build without external inference algorithm GCO")
endif(WITH_GCO)

#--------------------------------------------------------------
# MRF
#--------------------------------------------------------------
if(WITH_MRF)
   message(STATUS "build with external inference algorithm MRF")
   SET(MRF_LABEL_VALUE "int" CACHE STRING "selected label type for MRF library")
   add_definitions(-DMRFLABELVALUE=${MRF_LABEL_VALUE})
   SET(MRF_ENERGY_VALUE "double" CACHE STRING "selected energy type for MRF library")
   add_definitions(-DMRFENERGYVALUE=${MRF_ENERGY_VALUE})
   SET(MRF_COST_VALUE "double" CACHE STRING "selected cost type for MRF library")
   add_definitions(-DMRFCOSTVALUE=${MRF_COST_VALUE})
   SET(MRF_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/MRF-v2.1.src-patched" CACHE STRING "MRF patched source code directory") 
 
   add_definitions(-DWITH_MRF)
   include_directories(${MRF_PATCHEDSRCDIR})

   set(bitness 32)
   if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      MESSAGE (STATUS "Detected a 64 Bit Machine")
      set(bitness 64)
      add_definitions(-DUSE_64_BIT_PTR_CAST)
   else()
      MESSAGE (STATUS "Detected a 32 Bit Machine")
   endif()
  
   #TODO add 64 bit check here!
   #if(64Bit???)
     #add_definitions(-DUSE_64_BIT_PTR_CAST)
   #endif(64Bit???)      
else()
   message(STATUS "build without external inference algorithm MRF")
endif(WITH_MRF)

#--------------------------------------------------------------
# QPBO
#--------------------------------------------------------------
if(WITH_QPBO)
   message(STATUS "build with external inference algorithm QPBO")
   SET(QPBO_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/QPBO-v1.3.src-patched" CACHE STRING "QPBO patched source code directory")
   add_definitions(-DWITH_QPBO)
   include_directories(${QPBO_PATCHEDSRCDIR})
else()
   message(STATUS "build without external inference algorithm QPBO")
endif(WITH_QPBO)

#--------------------------------------------------------------
# FastPD
#--------------------------------------------------------------
if(WITH_FASTPD)
   message(STATUS "build with external inference algorithm FastPD")
   SET(FASTPD_URL "" CACHE STRING "URL for downloading FastPD (Registration required at http://www.csd.uoc.gr/~komod/FastPD/)")
   SET(FASTPD_ENERGY_VALUE "double" CACHE STRING "selected energy type for FASTPD library")
   add_definitions(-DFASTPDENERGYVALUE=${FASTPD_ENERGY_VALUE})
   SET(FASTPD_LABEL_VALUE "size_t" CACHE STRING "selected label type for FASTPD library")
   add_definitions(-DFASTPDLABELVALUE=${FASTPD_LABEL_VALUE})
   SET(FASTPD_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/FastPD.src-patched" CACHE STRING "FastPD patched source code directory")
   add_definitions(-DWITH_FASTPD)

=== src/converter/CMakeLists.txt ===
if(BUILD_CONVERTER)
  #  if(WITH_HDF5 AND WITH_BOOST)
  #      find_package(Boost 1.47 REQUIRED COMPONENTS program_options)
  #      message(STATUS "adding FORMAT CONVERTER")
  #      add_executable(opengm1TOopengm2 opengm1TOopengm2.cxx ${headers})
  #      target_link_libraries(opengm1TOopengm2 ${HDF5_CORE_LIBRARY} ${Boost_PROGRAM_OPTIONS_LIBRARY})
  #      if(UNIX)
  #          find_library(RT rt)
  #          target_link_libraries(opengm1TOopengm2 rt)
  #      endif(UNIX)
  #      INSTALL_TARGETS(/bin/converter opengm1TOopengm2)
  #  else()
  #      message(STATUS "Not building format converter **")
  #  endif()

    if(WITH_HDF5)    
      add_executable(opengm2uai opengm2uai.cxx ${headers})
      target_link_libraries(opengm2uai ${HDF5_LIBRARIES})  
      INSTALL_TARGETS(/bin/converter opengm2uai)
      
      add_executable(uai2opengm uai2opengm.cxx ${headers})
      target_link_libraries(uai2opengm ${HDF5_LIBRARIES})  
      INSTALL_TARGETS(/bin/converter uai2opengm)
      
      add_executable(partition2potts partition2potts.cxx ${headers})
      target_link_libraries(partition2potts ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter partition2potts) 

      add_executable(brain brain.cxx ${headers})
      target_link_libraries(brain ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter brain)
      
      add_executable(opengm2wudag opengm2wudag.cxx ${headers})
      target_link_libraries(opengm2wudag ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter opengm2wudag)
    
    endif()
endif()

=== src/unittest/CMakeLists.txt ===

add_definitions(-DOPENGM_DEBUG)

if(BUILD_TESTING)

   add_executable(test-partitions test_partitions.cxx ${headers})
   add_test(test-partitions ${CMAKE_CURRENT_BINARY_DIR}/test-partitions)


   add_executable(test-gm-learning-functions test_gm_learning_functions.cxx ${headers})
   add_test(test-gm-learning-functions ${CMAKE_CURRENT_BINARY_DIR}/test-gm-learning-functions)


   add_executable(test-graphicalmodelmanipulator test_graphicalmodelmanipulator.cxx ${headers})
   add_test(test-graphicalmodelmanipulator ${CMAKE_CURRENT_BINARY_DIR}/test-graphicalmodelmanipulator)

   add_executable(test-explicit-storage test_explicit_storage.cxx ${headers})
   add_test(test-explicit-storage ${CMAKE_CURRENT_BINARY_DIR}/test-explicit-storage)

   add_executable(test-types test_types.cxx ${headers})
   add_test(test-types ${CMAKE_CURRENT_BINARY_DIR}/test-types)

   add_executable(test-test-type-sizes-for-hdf5 test_type_sizes_for_hdf5.cxx ${headers})
   add_test(test-test-type-sizes-for-hdf5 ${CMAKE_CURRENT_BINARY_DIR}/test-test-type-sizes-for-hdf5)

   #add_executable(test-sparsemarray test_sparsemarray.cxx ${headers})
   add_test(test-fast-sequence ${CMAKE_CURRENT_BINARY_DIR}/test-fast-sequen)
   add_executable(test-fast-sequence test_fast_sequence.cxx ${headers})
   add_test(test-fast-sequence ${CMAKE_CURRENT_BINARY_DIR}/test-fast-sequence)

   add_executable(test-functions test_functions.cxx ${headers})
   add_test(test-functions ${CMAKE_CURRENT_BINARY_DIR}/test-functions)

   add_executable(test-factor test_factor.cxx ${headers})
   add_test(test-factor ${CMAKE_CURRENT_BINARY_DIR}/test-factor)

   add_executable(test-discretespaces test_discretespaces.cxx ${headers})
   add_test(test-discretespaces ${CMAKE_CURRENT_BINARY_DIR}/test-discretespaces)

   add_executable(test-graphicalmodel test_graphicalmodel.cxx ${headers})
   add_test(test-graphicalmodel ${CMAKE_CURRENT_BINARY_DIR}/test-graphicalmodel)

   add_executable(test-factorgraph test_factorgraph.cxx ${headers})
   add_test(test-factorgraph ${CMAKE_CURRENT_BINARY_DIR}/test-factorgraph)

   add_executable(test-graphicalmodeldecomposer test_graphicalmodeldecomposer.cxx ${headers})
   add_test(test-graphicalmodeldecomposer ${CMAKE_CURRENT_BINARY_DIR}/test-graphicalmodeldecomposer)

   add_executable(test-operate test_operate.cxx ${headers})
   add_test(test-operate ${CMAKE_CURRENT_BINARY_DIR}/test-operate)

   add_executable(test-operations test_operations.cxx ${headers})
   add_test(test-operations ${CMAKE_CURRENT_BINARY_DIR}/test-operations)

   add_executable(test-accumulate test_accumulate.cxx ${headers})
   add_test(test-accumulate ${CMAKE_CURRENT_BINARY_DIR}/test-accumulate)

   add_executable(test-randomaccessset test_randomaccessset.cxx ${headers})
   add_test(test-randomaccessset ${CMAKE_CURRENT_BINARY_DIR}/test-randomaccessset)

   add_executable(test-tribool test_tribool.cxx ${headers})
   add_test(test-tribool ${CMAKE_CURRENT_BINARY_DIR}/test-tribool)

   add_executable(test-accessor-iterator test_accessor_iterator.cxx ${headers})
   add_test(test-accessor-iterator ${CMAKE_CURRENT_BINARY_DIR}/test-accessor-iterator)

   add_executable(test-random test_random_1.cxx ${headers})
   add_test(test-random ${CMAKE_CURRENT_BINARY_DIR}/test-random) 

   ADD_EXECUTABLE(test-primal-lpbound test_primal_lpbound.cpp ${headers}) 
   add_test(test-primal-lpbound ${CMAKE_CURRENT_BINARY_DIR}/test-primal-lpbound) 

   ADD_EXECUTABLE(test-transportsolver test_transportsolver.cpp ${headers})
   add_test(test-transportsolver ${CMAKE_CURRENT_BINARY_DIR}/test-transportsolver) 

   if(WITH_HDF5)
      add_executable(test-io-hdf5 test_io_hdf5.cxx ${headers})
      target_link_libraries(test-io-hdf5 ${HDF5_LIBRARIES})
      add_test(test-io-hdf5 ${CMAKE_CURRENT_BINARY_DIR}/test-io-hdf5)
   endif()

   ADD_EXECUTABLE(test-memoryinfo test_memoryinfo.cxx ${headers})
   add_test(test-memoryinfo ${CMAKE_CURRENT_BINARY_DIR}/test-memoryinfo) 

   add_executable(test-lp-solver test_lp_solver.cxx ${headers})
   add_test(test-lp-solver ${CMAKE_CURRENT_BINARY_DIR}/test-lp-solver) 
   if(WITH_CPLEX)
      if(WIN32)
         target_link_libraries(test-lp-solver wsock32.lib ${CPLEX_LIBRARIES} )
      else(WIN32)
         target_link_libraries(test-lp-solver ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
      endif(WIN32)
   endif(WITH_CPLEX)
   if(WITH_GUROBI)
      target_link_libraries(test-lp-solver
         ${GUROBI_LIBRARIES}
         ${GUOBI_CXX_LIBRARY}  
         ${GUROBI_LIBRARY}
         ${CMAKE_THREAD_LIBS_INIT}
      )
   endif(WITH_GUROBI)
   if(LINK_RT)
      target_link_libraries(test-lp-solver rt)
   endif(LINK_RT)
   
   add_executable(test-indicator-variable test_indicator_variable.cxx ${headers})
   add_test(test-indicator-variable ${CMAKE_CURRENT_BINARY_DIR}/test-indicator-variable)
   
   add_executable(test-linear-constraint test_linear_constraint.cxx ${headers})
   add_test(test-linear-constraint ${CMAKE_CURRENT_BINARY_DIR}/test-linear-constraint)
   
   add_executable(test-subsequence-iterator test_subsequence_iterator.cxx ${headers})
   add_test(test-subsequence-iterator ${CMAKE_CURRENT_BINARY_DIR}/test-subsequence-iterator)
   
   add_executable(test-lp-functiontransfer test_lp_functiontransfer.cxx ${headers})
   add_test(test-lp-functiontransfer ${CMAKE_CURRENT_BINARY_DIR}/test-lp-functiontransfer)
   
   add_executable(test-canonicalview test_canonicalview.cxx ${headers})
   add_test(test-canonicalview ${CMAKE_CURRENT_BINARY_DIR}/test-canonicalview)

   add_subdirectory(inference)
endif()

=== src/examples/constrained-graphical-models-examples/CMakeLists.txt ===
IF(WITH_CPLEX OR WITH_GUROBI)
   ADD_EXECUTABLE(example-foreground-background-segmentation foreground_background_segmentation.cxx ${headers})

   IF(WITH_CPLEX)
      IF(WIN32)
         TARGET_LINK_LIBRARIES(example-foreground-background-segmentation wsock32.lib ${CPLEX_LIBRARIES})
      ELSE(WIN32)
         TARGET_LINK_LIBRARIES(example-foreground-background-segmentation ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES})
      ENDIF(WIN32)
   ENDIF(WITH_CPLEX)

   IF(WITH_GUROBI)
      TARGET_LINK_LIBRARIES(example-foreground-background-segmentation ${CMAKE_THREAD_LIBS_INIT} ${GUROBI_LIBRARIES})
   ENDIF(WITH_GUROBI)

   IF(WITH_HDF5 AND HDF5_FOUND)
      TARGET_LINK_LIBRARIES(example-foreground-background-segmentation ${HDF5_LIBRARIES})
   ENDIF(WITH_HDF5 AND HDF5_FOUND)
   
   IF(NOT(WIN32 OR APPLE))
      TARGET_LINK_LIBRARIES(example-foreground-background-segmentation rt)
   ENDIF(NOT(WIN32 OR APPLE))
ELSE(WITH_CPLEX OR WITH_GUROBI)
   MESSAGE("Constrained Graphical Models Examples require Cplex or Gurobi")  
ENDIF(WITH_CPLEX OR WITH_GUROBI)

=== src/examples/unsorted-examples/CMakeLists.txt ===
#add_executable(example-gibbs gibbs.cxx ${headers})
add_executable(example-inference-types inference_types.cxx ${headers})
add_executable(example-markov-chain markov-chain.cxx ${headers})
add_executable(example-matching one_to_one_matching.cxx ${headers})
add_executable(example-quick-start quick_start.cxx ${headers})
add_executable(example-space-types space_types.cxx ${headers})
#add_executable(example-swendsenwang swendsenwang.cxx ${headers})

if(WIN32 OR APPLE)

else( )
   find_library(RT_LIBRARY rt)
   target_link_libraries(example-quick-start rt)
   target_link_libraries(example-matching rt)
   target_link_libraries(example-space-types rt)
endif()

=== src/external/patches/CMakeLists.txt ===

set(externalLibs_scripts
    MaxFlow/patchMaxFlow-v3.02.sh
    MRF/patchMRF-v2.1.sh
)

add_custom_target(externalLibs
                  COMMENT "Download, patch and install external libraries used by openGM"
)

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchAD3.sh
                   COMMENT "AD3"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/AD3"
)


add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchMRF-v2.1.sh
                   COMMENT "MRF"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/MRF"
)

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchGCO.sh
                   COMMENT "GCO"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/GCO"
)

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchMaxFlow-v3.02.sh
                   COMMENT "MaxFlow"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/MaxFlow"
)   

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchQPBO-v1.3.sh
                   COMMENT "QPBO"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/QPBO"
)

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchTRWS-v1.3.sh
                   COMMENT "TRWS"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/TRWS"
)

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchConicBundle-v0.3.11.sh
                   COMMENT "ConicBundle"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/ConicBundle"
)
  
add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchIBFS.sh
                   COMMENT "IBFS"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/IBFS"
)  
                           
add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchFastPD.sh ARGS ${FASTPD_URL}
                   COMMENT "FastPD"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/FastPD"
)   

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchGrante-v1.0.sh
                   COMMENT "Grante"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/grante"
)                 

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchDAOOPT.sh
                   COMMENT "DAOOPT"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/DAOOPT"
) 

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchmplp_ver2.sh
                   COMMENT "MPLP"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/MPLP"
) 

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchPlanarity.sh
                   COMMENT "Planarity"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Planarity"
) 

add_custom_command(TARGET externalLibs PRE_BUILD                   
                   COMMAND ./patchBlossom5.sh
                   COMMENT "Blossom5"
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Blossom5"
) 

IF(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../SRMP")
  add_custom_command(TARGET externalLibs PRE_BUILD                   
    COMMAND git clone https://github.com/opengm/SRMP.git
    COMMENT "SRMP"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../"
  )
ENDIF()

=== src/interfaces/python/CMakeLists.txt ===
#add_definitions(-DNPY_NO_DEPRECATED_API)
#add_definitions(-DNPY_1_7_API_VERSION)

add_subdirectory(opengm)
if( ${CMAKE_CURRENT_SOURCE_DIR} STREQUAL  ${CMAKE_CURRENT_BINARY_DIR} )
   message(STATUS "same src and build dir.")
else()
   message(STATUS "copy test.py" )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/test.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   cmake_minimum_required(VERSION 2.8)
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/examples/ DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/examples )
endif()

option(BUILD_PYTHON_DOCS "Build the Python documentation with Sphinx" OFF)

if(BUILD_PYTHON_DOCS)
    find_package(SPHINX REQUIRED)

        if(NOT DEFINED SPHINX_THEME)
            set(SPHINX_THEME default)
        endif()
        if(NOT DEFINED SPHINX_THEME_DIR)
            set(SPHINX_THEME_DIR)
        endif()
        # configured documentation tools and intermediate build results
        set(SPHINX_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/doc/_build")
        # Sphinx cache with pickled ReST documents
        set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/doc/_doctrees")
        # HTML output directory
        set(SPHINX_HTML_DIR "${CMAKE_CURRENT_BINARY_DIR}/doc/html")
        configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/docsrc/source/conf.py.in"
            "${SPHINX_BUILD_DIR}/conf.py"
            @ONLY)
        add_custom_target(python-doc ALL
            ${SPHINX_EXECUTABLE}
            -q -b html
            -c "${SPHINX_BUILD_DIR}"
            -d "${SPHINX_CACHE_DIR}"
            "${CMAKE_CURRENT_SOURCE_DIR}/docsrc/source"
            "${SPHINX_HTML_DIR}"
            COMMENT "Building HTML documentation with Sphinx")
        install(DIRECTORY ${SPHINX_HTML_DIR}
            DESTINATION share/doc/python-opengm
        )
        add_dependencies(python-doc _opengmcore )
        add_dependencies(python-doc _inference )
        add_dependencies(python-doc _hdf5 )
endif()

=== src/unittest/inference/CMakeLists.txt ===




ADD_EXECUTABLE(test-adsal test_adsal.cxx ${headers})
#set_target_properties(test-adsal PROPERTIES COMPILE_DEFINITIONS "OPENGM_TESTFILE") 
#target_link_libraries(test-adsal ${HDF5_LIBRARIES})
add_test(test-adsal ${CMAKE_CURRENT_BINARY_DIR}/test-adsal)
 
 ADD_EXECUTABLE(test-nesterov test_nesterov.cxx ${headers})
 #set_target_properties(test-nesterov PROPERTIES COMPILE_DEFINITIONS "OPENGM_TESTFILE") 
 #target_link_libraries(test-nesterov ${HDF5_LIBRARIES})
 add_test(test-nesterov ${CMAKE_CURRENT_BINARY_DIR}/test-nesterov) 
#  if(WITH_HDF5)
#      add_executable(test-nesterov test_nesterov.cxx ${headers})
#      target_link_libraries(test-nesterov ${HDF5_LIBRARIES})
#      add_test(test-nesterov ${CMAKE_CURRENT_BINARY_DIR}/test-nesterov)
#   endif()



ADD_EXECUTABLE(test-trwsi test_trwsi.cxx ${headers})
#set_target_properties(test-trwsi PROPERTIES COMPILE_DEFINITIONS "OPENGM_TESTFILE") 
#target_link_libraries(test-trwsi ${HDF5_LIBRARIES})
add_test(test-trwsi ${CMAKE_CURRENT_BINARY_DIR}/test-trwsi)


add_executable(test-messagepassing test_messagepassing.cxx ${headers})
add_test(test-messagepassing ${CMAKE_CURRENT_BINARY_DIR}/test-messagepassing)

add_executable(test-dynamicprogramming test_dynamicprogramming.cxx ${headers})
add_test(test-dynamicprogramming ${CMAKE_CURRENT_BINARY_DIR}/test-dynamicprogramming)

#add_executable(test-gibbs test_gibbs.cxx ${headers})
#add_test(test-gibbs ${CMAKE_CURRENT_BINARY_DIR}/test-gibbs)

#add_executable(test-swendsenwang test_swendsenwang.cxx ${headers})
#add_test(test-swendsenwang ${CMAKE_CURRENT_BINARY_DIR}/test-swendsenwang)

#add_executable(test-pbp test_pbp.cxx ${headers})
#add_test(test-pbp ${CMAKE_CURRENT_BINARY_DIR}/test-pbp)



##########################
# self fusion and fusion based
#########################
add_executable(test-self-fusion test_self_fusion.cxx ${headers})
add_executable(test-fusion-based-inf test_fusion_based_inf.cxx ${headers})

#target_link_libraries(test-self-fusion      pthread)
#target_link_libraries(test-fusion-based-inf pthread)


if(WITH_QPBO) 
  target_link_libraries(test-self-fusion external-library-qpbo)
  target_link_libraries(test-fusion-based-inf external-library-qpbo)
endif()
if(WITH_CPLEX) 
  if(WIN32)
    target_link_libraries(test-self-fusion wsock32.lib ${CPLEX_LIBRARIES} )
    target_link_libraries(test-fusion-based-inf wsock32.lib ${CPLEX_LIBRARIES} )
  else()
    target_link_libraries(test-self-fusion      ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
    target_link_libraries(test-fusion-based-inf ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
  endif()
endif()

add_test(test-self-fusion ${CMAKE_CURRENT_BINARY_DIR}/test-self-fusion)
add_test(test-fusion-based-inf  ${CMAKE_CURRENT_BINARY_DIR}/test-fusion-based-inf)

if(WITH_AD3) 
  add_executable(test-loc test_loc.cxx ${headers})
  target_link_libraries(test-loc external-library-ad3 )
  if(LINK_RT)
   find_library(RT rt)
   target_link_libraries(test-loc rt)
  endif(LINK_RT)

  if(WITH_CPLEX)
  if(WIN32)
    target_link_libraries(test-loc wsock32.lib ${CPLEX_LIBRARIES} )
  else()
    target_link_libraries(test-loc ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
  endif()
endif()



  add_test(test-loc ${CMAKE_CURRENT_BINARY_DIR}/test-loc)
endif()



add_executable(test-icm test_icm.cxx ${headers})
add_test(test-icm ${CMAKE_CURRENT_BINARY_DIR}/test-icm)

add_executable(test-bruteforce test_bruteforce.cxx ${headers})
add_test(test-bruteforce ${CMAKE_CURRENT_BINARY_DIR}/test-bruteforce)

add_executable(test-lazyflipper test_lazyflipper.cxx ${headers})
add_test(test-lazyflipper  ${CMAKE_CURRENT_BINARY_DIR}/test-lazyflipper)

add_executable(test-movemaker test_movemaker.cxx ${headers})
if(LINK_RT)
   find_library(RT rt)
   target_link_libraries(test-movemaker rt)
endif(LINK_RT)
add_test(test-movemaker ${CMAKE_CURRENT_BINARY_DIR}/test-movemaker)


add_executable(test-dualdecomposition test_dualdecomposition.cxx ${headers})
add_test(test-dualdecomposition ${CMAKE_CURRENT_BINARY_DIR}/test-dualdecomposition)
if(LINK_RT)
  find_library(RT rt)
  target_link_libraries(test-dualdecomposition rt)
  if(WITH_CONICBUNDLE)
    target_link_libraries(test-dualdecomposition ${CONICBUNDLE_LIBRARY})
  endif()
endif(LINK_RT)
if(APPLE AND WITH_CONICBUNDLE)
  target_link_libraries(test-dualdecomposition ${CONICBUNDLE_LIBRARY})
endif()

add_executable(test-astar test_astar.cxx ${headers})
if(LINK_RT)
   find_library(RT rt)
   target_link_libraries(test-astar rt)
endif(LINK_RT)
add_test(test-astar  ${CMAKE_CURRENT_BINARY_DIR}/test-astar)

if(WITH_BOOST)
   add_executable(test-2sat test_2sat.cxx ${headers})
   add_test(test-2sat ${CMAKE_CURRENT_BINARY_DIR}/test-2sat)
endif()

if(WITH_BOOST OR WITH_MAXFLOW OR WITH_MAXFLOW_IBFS)
   add_executable(test-minstcut test_minstcut.cxx ${headers})
   add_executable(test-graphcut test_graphcut.cxx ${headers})
   add_executable(test-alphaexpansion test_alphaexpansion.cxx ${headers})
   add_executable(test-alphabetaswap test_alphabetaswap.cxx ${headers})
   add_executable(test-qpbo test_qpbo.cxx ${headers})
   IF(WITH_MAXFLOW)
      target_link_libraries(test-minstcut external-library-maxflow)
      target_link_libraries(test-graphcut external-library-maxflow)
      target_link_libraries(test-alphaexpansion external-library-maxflow)
      target_link_libraries(test-alphabetaswap external-library-maxflow)
      target_link_libraries(test-qpbo external-library-maxflow)
   endif(WITH_MAXFLOW)
   IF(WITH_MAXFLOW_IBFS)
     target_link_libraries(test-graphcut external-library-maxflow-ibfs)
   endif(WITH_MAXFLOW_IBFS)
   add_test(test-minstcut  ${CMAKE_CURRENT_BINARY_DIR}/test-minstcut)
   add_test(test-graphcut  ${CMAKE_CURRENT_BINARY_DIR}/test-graphcut)
   add_test(test-alphabetaswap  ${CMAKE_CURRENT_BINARY_DIR}/test-alphabetaswap)
   add_test(test-alphaexpansion  ${CMAKE_CURRENT_BINARY_DIR}/test-alphaexpansion)
   add_test(test-qpbo ${CMAKE_CURRENT_BINARY_DIR}/test-qpbo)
endif()

if(WITH_CPLEX)
  add_executable(test-lpcplex test_lpcplex.cxx ${headers})
  add_executable(test-lpcplex2 test_lpcplex2.cxx ${headers})
  add_executable(test-combilp test_combilp.cxx ${headers})
  if(WIN32)
    target_link_libraries(test-lpcplex wsock32.lib ${CPLEX_LIBRARIES} )
    target_link_libraries(test-lpcplex2 wsock32.lib ${CPLEX_LIBRARIES} )
    target_link_libraries(test-combilp wsock32.lib ${CPLEX_LIBRARIES} ${HDF5_LIBRARIES} ) 
  else(WIN32)
    target_link_libraries(test-lpcplex ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
    target_link_libraries(test-lpcplex2 ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES})
    target_link_libraries(test-combilp ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} ${HDF5_LIBRARIES}) 
  endif(WIN32)
  if(LINK_RT)
    target_link_libraries(test-combilp rt)
  endif(LINK_RT)
  
  add_test(test-lpcplex ${CMAKE_CURRENT_BINARY_DIR}/test-lpcplex)
  add_test(test-lpcplex2 ${CMAKE_CURRENT_BINARY_DIR}/test-lpcplex2)
  add_test(test-combilp ${CMAKE_CURRENT_BINARY_DIR}/test-combilp)
endif(WITH_CPLEX)


if(WITH_GUROBI)
  set (CMAKE_CXX_FLAGS "-fno-stack-protector")
  set (CMAKE_LINKER_FLAGS "-lm")
  set (CMAKE_LINK_FLAGS "-lm") 


  add_executable(test-lpgurobi test_lpgurobi.cxx ${headers})
  add_executable(test-lpgurobi2 test_lpgurobi2.cxx ${headers})
  target_link_libraries(test-lpgurobi ${CMAKE_THREAD_LIBS_INIT} 
    ${GUROBI_LIBRARIES}
    #${GUOBI_CXX_LIBRARY}  
    #${GUROBI_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    #${GUROBI_LIBRARIES}
    #
  )
  target_link_libraries(test-lpgurobi2 ${CMAKE_THREAD_LIBS_INIT} 
    ${GUROBI_LIBRARIES}
    #${GUOBI_CXX_LIBRARY}  
    #${GUROBI_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    #${GUROBI_LIBRARIES}
    #
  )
  add_test(test-lpgurobi ${CMAKE_CURRENT_BINARY_DIR}/test-lpgurobi)
  add_test(test-lpgurobi2 ${CMAKE_CURRENT_BINARY_DIR}/test-lpgurobi2)

  message(STATUS "GRB LB: ${GUROBI_LIBRARIES}")
endif()


if(WITH_CPLEX)
  if(WITH_BOOST OR CMAKE_COMPILER_IS_GNUCC)
    add_executable(test-multicut test_multicut.cxx ${headers})
    if(WIN32)
      target_link_libraries(test-multicut wsock32.lib ${CPLEX_LIBRARIES} )  
    else()
      target_link_libraries(test-multicut ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
    endif()
    if(LINK_RT)
      target_link_libraries(test-multicut rt)
    endif(LINK_RT) 
    add_test(test-multicut ${CMAKE_CURRENT_BINARY_DIR}/test-multicut)
  endif()
endif()

if(WITH_QPBO) 
   add_executable(test-qpbo-external test_qpbo_external.cxx ${headers})
   target_link_libraries(test-qpbo-external external-library-qpbo)
   add_test(test-qpbo-external ${CMAKE_CURRENT_BINARY_DIR}/test-qpbo-external)

   add_executable(test-mqpbo test_mqpbo.cxx ${headers})
   target_link_libraries(test-mqpbo external-library-qpbo)
   add_test(test-mqpbo ${CMAKE_CURRENT_BINARY_DIR}/test-mqpbo)
endif()

if(WITH_BOOST)
  if(WITH_QPBO)
    add_executable(test-rinf test_rinf.cxx ${headers})
    target_link_libraries(test-rinf external-library-qpbo)
    add_test(test-rinf ${CMAKE_CURRENT_BINARY_DIR}/test-rinf)
  endif()
endif()

if(WITH_AD3) 
   add_executable(test-ad3-external test_ad3_external.cxx ${headers})
   target_link_libraries(test-ad3-external external-library-ad3 )
   add_test(test-ad3-external ${CMAKE_CURRENT_BINARY_DIR}/test-ad3-external)
endif()


if(WITH_BOOST)
  if(WITH_QPBO)
    add_executable(test-alphaexpansionfusion test_alphaexpansionfusion.cxx ${headers})
    target_link_libraries(test-alphaexpansionfusion external-library-qpbo)
    add_test(test-alphaexpansionfusion ${CMAKE_CURRENT_BINARY_DIR}/test-alphaexpansionfusion)
  endif()
endif()

if(WITH_TRWS)
   add_executable(test-trws test_trws.cxx ${headers})
   target_link_libraries(test-trws external-library-trws)
   add_test(test-trws ${CMAKE_CURRENT_BINARY_DIR}/test-trws)
endif()


if(WITH_MRF)
   add_executable(test-mrflib test_mrflib.cxx ${headers})
   target_link_libraries(test-mrflib external-library-mrf)
   add_test(test-mrflib ${CMAKE_CURRENT_BINARY_DIR}/test-mrflib)
endif()

if(WITH_LIBDAI)
   add_executable(test-opengm-libdai-interface test_external_libdai.cxx ${headers})
   target_link_libraries(test-opengm-libdai-interface ${LIBDAI_LIBRARY})
   target_link_libraries(test-opengm-libdai-interface ${GMPXX_LIBRARY})
   target_link_libraries(test-opengm-libdai-interface ${GMP_LIBRARY}) 
   add_test(test-opengm-libdai-interface  ${CMAKE_CURRENT_BINARY_DIR}/test-opengm-libdai-interface)
endif()

if(WITH_GCO)
   add_executable(test-gco test_gco.cxx ${headers})
   target_link_libraries(test-gco external-library-gco)
   add_test(test-gco ${CMAKE_CURRENT_BINARY_DIR}/test-gco)
endif()

if(WITH_MPLP)
   if(TARGET external-library-mplp)
      message(STATUS "target exists") 
   else(TARGET external-library-mplp)
      message(STATUS "target does not exist!")
   endif(TARGET external-library-mplp)
   add_executable(test-mplp-external test_mplp_external.cxx ${headers})
   target_link_libraries(test-mplp-external external-library-mplp)
   add_test(test-mplp-external ${CMAKE_CURRENT_BINARY_DIR}/test-mplp-external)
endif() 

if(WITH_SRMP)
   if(TARGET external-library-srmp)
      message(STATUS "target exists") 
   else(TARGET external-library-srmp)
      message(STATUS "target does not exist!")
   endif(TARGET external-library-srmp)
   
   add_executable(test-srmp-external test_srmp_external.cxx ${headers})
   target_link_libraries(test-srmp-external external-library-srmp)
   add_test(test-srmp-external ${CMAKE_CURRENT_BINARY_DIR}/test-srmp-external) 
   if(LINK_RT)
     find_library(RT rt)
     target_link_libraries(test-srmp-external rt)
   endif(LINK_RT)
endif(WITH_SRMP)
 
if(WITH_MAXFLOW)
  add_executable(test-lsatr test_lsatr.cxx ${headers})
  target_link_libraries(test-lsatr external-library-maxflow)
  add_test(test-lsatr ${CMAKE_CURRENT_BINARY_DIR}/test-lsatr)
endif()

if(WITH_LIBDAI)
  add_executable(test-libdai test_libdai.cxx ${headers})
  target_link_libraries(test-libdai ${LIBDAI_LIBRARY})
  target_link_libraries(test-libdai ${GMP_LIBRARY})
  target_link_libraries(test-libdai ${GMPXX_LIBRARY})

=== src/interfaces/matlab/opengm/CMakeLists.txt ===
add_subdirectory(mex-src)
add_subdirectory(matlab-examples)

=== src/interfaces/python/opengm/CMakeLists.txt ===
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    # a lot of warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -s")
elseif(MSVC)
   # how to stripe wihtn msvc
   #add_definitions(-Ds) ????
endif()



#--------------------------------------------------------------
# Find packages
#--------------------------------------------------------------
if ( WITH_BOOST )
   find_package(Boost COMPONENTS python REQUIRED)
else()
   message( FATAL_ERROR "Option  WITH_BOOST  needs to be activated to compile the OpenGM Python Wrapper" )
endif()

find_package(NUMPY REQUIRED)
find_package(PythonLibs REQUIRED)
#--------------------------------------------------------------
# Include Directories
#--------------------------------------------------------------
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
	 ${PYTHON_INCLUDE_DIRS}
	 ${PYTHON_NUMPY_INCLUDE_DIR}
    ${Boost_INCLUDE_DIR}
    ${Boost_PYTHON_INCLUDE_DIR}
)






add_subdirectory(opengmcore)
add_subdirectory(inference)
add_subdirectory(hdf5)
add_subdirectory(benchmark)

#--------------------------------------------------------------
# Copy from src to build
#--------------------------------------------------------------

if( ${CMAKE_CURRENT_SOURCE_DIR} STREQUAL  ${CMAKE_CURRENT_BINARY_DIR} )
   message(STATUS "same src and build dir.")
else()
   message(STATUS "copy python-opengm files  from src to build" )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_misc.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/__version__.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )

   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_visu.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_inf_param.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_to_native_converter.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_inference_parameter_injector.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_inference_injector.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/_inference_interface_generator.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/functionhelper.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
endif()

=== src/tutorials/c++/applications/CMakeLists.txt ===
add_executable(imageSegSimple    imageSegSimple.cxx            ${headers})
add_executable(imageSegWithEMLearning imageSegWithEMLearning.cxx   ${headers})

if(WITH_HDF5)
  add_executable(buildFoE buildFoE.cxx   ${headers})
  target_link_libraries(buildFoE ${HDF5_LIBRARIES}) 
endif()


find_package(VIGRA)	
IF(VIGRA_FOUND)
  #file(GLOB_RECURSE mrfheaders utility/*.hxx)
  #include_directories(utility)
  include_directories(${VIGRA_INCLUDE_DIR})
  if(WITH_HDF5)
    message(STATUS "build with mrf-benchmark")
    #add_executable(photomontage photomontage.cxx ${headers} ${mrfheaders} ${VIGRA_INCLUDE_DIR}) 
    add_executable(photomontage-stitching photomontage-stitching.cxx ${headers}  ${VIGRA_INCLUDE_DIR}) 
    add_executable(photomontage-merging photomontage-merging.cxx ${headers} ${VIGRA_INCLUDE_DIR})
    add_executable(denoise denoise.cxx ${headers} ${mrfheaders} ${VIGRA_INCLUDE_DIR})
    
    target_link_libraries(photomontage-stitching ${HDF5_CORE_LIBRARY} ${VIGRA_IMPEX_LIBRARY}) 
    target_link_libraries(photomontage-merging ${HDF5_CORE_LIBRARY} ${VIGRA_IMPEX_LIBRARY}) 
    target_link_libraries(denoise ${HDF5_LIBRARIES} ${VIGRA_IMPEX_LIBRARY}) 
    if(UNIX)
      if(LINK_RT)
        find_library(RT_LIBRARY rt)
        target_link_libraries(photomontage-stitching rt)
        target_link_libraries(photomontage-merging rt)
        target_link_libraries(denoise rt)
      endif()
    endif()
  else()
    message(STATUS "mrf-benchmark can only be built with HDF5. set WITH_HDF5 to build to HDF5.")
  endif()
endif()

=== src/interfaces/matlab/opengm/matlab-examples/CMakeLists.txt ===
if(WITH_MATLAB)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMATLAB_MEX_FILE -fPIC -ansi -shared -Wl,--version-script,${MATLAB_LIBRARY_DIR}/mexFunction.map")  

  add_executable(opengmBuild.${MATLAB_MEXEXT} opengmBuild.cxx ${headers})
  target_link_libraries(opengmBuild.${MATLAB_MEXEXT} ${HDF5_LIBRARIES}) 

  add_executable(opengmBuildGrid.mexa64 opengmBuildGrid.cxx ${headers})
  target_link_libraries(opengmBuildGrid.mexa64 ${HDF5_LIBRARIES})

  add_executable(opengmBuildFGE.mexa64 opengmBuildFGE.cxx ${headers})
  target_link_libraries(opengmBuildFGE.mexa64 ${HDF5_LIBRARIES})

  add_executable(opengmBuildMatching.mexa64 opengmBuildMatching.cxx ${headers})
  target_link_libraries(opengmBuildMatching.mexa64 ${HDF5_LIBRARIES}) 
 
  add_executable(readCC.mexa64 readCC.cxx ${headers})
  target_link_libraries(readCC.mexa64 ${HDF5_LIBRARIES}) 

endif(WITH_MATLAB)

=== debian/changelog ===
opengm (2.3.6-2) unstable; urgency=medium

  [Andreas Tille]
  * Change source package priority to optional.

  [Ghislain Antony Vaillant]
  * gbp.conf: no patch numbering with gbp-pq.
  * Add patch fixing execution of testsuite on 32-bit arch.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 04 Dec 2015 09:49:43 +0000

opengm (2.3.6-1) unstable; urgency=low

  * Initial release. Closes: #801971

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 20 Oct 2015 18:20:38 +0100

=== debian/control ===
Source: opengm
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               libboost-dev,
               libboost-graph-dev,
               libboost-python-dev,
               libhdf5-dev,
               libvigraimpex-dev,
               python,
               python-nose,
               python-numpy
Build-Depends-Indep: doxygen,
                     graphviz,
                     python-sphinx
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/clblas.git
Homepage: http://hci.iwr.uni-heidelberg.de/opengm2/
X-Python-Version: >= 2.6

Package: libopengm-bin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command line tools for OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the commandline interface to the OpenGM library.

Package: libopengm-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Suggests: libopengm-doc
Description: C++ template library for discrete factor graph models
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the development headers for the OpenGM library.

Package: libopengm-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: API documentation for OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the API documentation for the OpenGM library.

Package: python-opengm
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Suggests: python-opengm-doc
Description: Python interface to OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the Python interface to the OpenGM library.

Package: python-opengm-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Description: documentation for the Python interface to OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the documentation for the Python interface to the
 OpenGM library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

# Hardening options.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Build options.
BUILD_OPTIONS = \
	-DBUILD_EXAMPLES=OFF \
	-DBUILD_TUTORIALS=OFF \
	-DBUILD_COMMANDLINE=ON \
	-DWITH_BOOST=ON \
	-DWITH_HDF5=ON \
	-DWITH_OPENMP=ON \
	-DWITH_VIGRA=ON \
	-DBUILD_CONVERTER=ON \
	-DBUILD_PYTHON_WRAPPER=ON

# Disable build of testsuite if nocheck is passed.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	BUILD_OPTIONS += -DBUILD_TESTING=ON
else
	BUILD_OPTIONS += -DBUILD_TESTING=OFF
endif

%:
	dh $@ --parallel --with python2 

override_dh_auto_configure-arch:
	dh_auto_configure -- \
		$(BUILD_OPTIONS) \
		-DBUILD_DOCS=OFF \
		-DBUILD_PYTHON_DOCS=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- \
		$(BUILD_OPTIONS) \
		-DBUILD_DOCS=ON \
		-DBUILD_PYTHON_DOCS=ON

override_dh_auto_install-arch:
	dh_auto_install --arch
	dh_numpy --package=python-opengm

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Run library testsuite.
	cd obj-* && \
	CTEST_OUTPUT_ON_FAILURE=1 ctest --force-new-ctest-process
	# Run Python testsuite.
	cd obj-* && \
	make test-python-wrapper
endif

override_dh_auto_test-indep:
	# Pass.

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --package=libopengm-doc
	dh_sphinxdoc --package=python-opengm-doc

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/opengm-$1\.tar\.gz/ \
https://github.com/opengm/opengm/tags .*/v?(\d\S*)\.tar\.gz
